
<script>
import './directives/Hover'
import {EventBus} from "./modules/EventBus";
import Configuration from './modules/Configuration'
export default {
  name: 'follow-mouse',
  props: {
    conf: {
      required: true,
      type: Configuration
    }
  },
  data() {
    return {
      xPoint: -this.conf.size,
      yPoint: -this.conf.size,
      hover: false,
      show: true
    }
  },
  mounted() {
    if (this.isMobile()) {
      this.show = false
      return
    }
    this.events()

  },
  beforeDestroy() {
    EventBus.$off('hover')
  },
  computed: {
    matrix() {
      this.$forceUpdate()
      return `transform: matrix(1, 0, 0, 1, ${this.xPoint - (this.conf.size / 2)}, ${this.yPoint - (this.conf.size / 2)});`
    },
    state() {
      return this.hover
    },

  },
  methods: {
    isMobile() {
      const toMatch = [
        /Android/i,
        /webOS/i,
        /iPhone/i,
        /iPad/i,
        /iPod/i,
        /BlackBerry/i,
        /Windows Phone/i
      ]

      return toMatch.some((toMatchItem) => {
        return navigator.userAgent.match(toMatchItem)
      })
    },
    events() {
      EventBus.$on('follow-mouse-over', () => {
        this.hover = true
      })
      EventBus.$on('follow-mouse-leave', () => {
        this.hover = false
      })

      document.addEventListener('mouseleave', () => {
        this.show = false
      })
      document.addEventListener('mouseenter', () => {
        this.show = true
      })

      document.addEventListener('mousemove', this.movement)
    },
    movement($event) {
      setTimeout(() => {
        this.xPoint = $event.clientX
        this.yPoint = $event.clientY
      }, this.conf.delay)
    }
  }
}
</script>

<template>
  <transition name="fade">
    <div
        v-if="show"
        id="follow-cursor"
        :class="[ 'm-follow-cursor', { '-hover': state }]"
        :style="`--point:${conf.size}px; --color:${conf.color}`"
    >
      <div class="m-follow-cursor__point" :style="matrix">
        <div class="m-follow-cursor__point--inner"/>
      </div>
    </div>
  </transition>
</template>

<style scoped lang="css">
.m-follow-cursor {
  --point: 10px;
  --color: #000;
}

.m-follow-cursor__point {
  top: 0;
  left: 0;
  position: fixed;
  width: var(--point);
  height: var(--point);
  pointer-events: none;
  user-select: none;
  z-index: 1000;
  backface-visibility: hidden;
  will-change: transform;
  mix-blend-mode: exclusion;
}

.m-follow-cursor__point--inner {
  position: absolute;
  width: 100%;
  height: 100%;
  top: 50%;
  left: 50%;
  border-radius: 50%;
  border-width: 1px;
  border-style: solid;
  border-color: var(--color);
  transform: translate(-50%, -50%) scale(1);
  transition: transform 0.3s ease-in-out;
}

.m-cursor.-hover .m-follow-cursor__point {
  border-color: transparent;
}

.m-follow-cursor.-hover .m-follow-cursor__point--inner {
  transform: translate(-50%, -50%) scale(2);
}

.fade-enter-active, .fade-leave-active {
  transition: opacity .6s;
}

.fade-enter, .fade-leave-to {
  opacity: 0;
}
</style>
